#!/usr/bin/python

import os

'''
Generate the engines of the pinyin.xml on the fly.
'''

pinyin_engine = \
'''		<engine>
			<name>pinyin</name>
			<language>zh_CN</language>
			<license>GPL</license>
			<author>Peng Huang &lt;shawn.p.huang@gmail.com&gt;
BYVoid &lt;byvoid1@gmail.com&gt;
Peng Wu &lt;alexepico@gmail.com&gt;</author>
			<icon>/usr/share/ibus-pinyin/icons/ibus-pinyin.svg</icon>
			<layout>us</layout>
			<longname>Pinyin</longname>
			<description>Pinyin input method</description>
			<rank>99</rank>
                        <!-- <hotkeys>Control+space,Alt+grave,Alt+Release+Alt_R</hotkeys> -->
                        <symbol>&#x4E2D;</symbol>
		</engine>'''

bopomofo_engine = \
'''		<engine>
			<name>bopomofo</name>
			<language>zh_TW</language>
			<license>GPL</license>
			<author>BYVoid &lt;byvoid1@gmail.com&gt;
Peng Huang &lt;shawn.p.huang@gmail.com&gt;
Peng Wu &lt;alexepico@gmail.com&gt;</author>
			<icon>/usr/share/ibus-pinyin/icons/ibus-bopomofo.svg</icon>
			<layout>us</layout>
			<longname>Bopomofo</longname>
			<description>Bopomofo input method</description>
			<rank>98</rank>
                        <!-- <hotkeys>Control+space,Alt+grave,Alt+Release+Alt_R</hotkeys> -->
                        <symbol>&#x4E2D;</symbol>
		</engine>'''

libpinyin_engine = \
'''		<engine>
			<name>libpinyin</name>
			<language>zh_CN</language>
			<license>GPL</license>
			<author>Peng Huang &lt;shawn.p.huang@gmail.com&gt;
                        Peng Wu &lt;alexepico@gmail.com&gt;
                        BYVoid &lt;byvoid1@gmail.com&gt;
                        </author>
			<icon>/usr/share/ibus-pinyin/icons/ibus-pinyin.svg</icon>
			<layout>us</layout>
			<longname>Intelligent Pinyin</longname>
			<description>Intelligent Pinyin input method</description>
			<rank>99</rank>
                        <!-- <hotkeys>Control+space,Alt+grave,Alt+Release+Alt_R</hotkeys> -->
                        <symbol>&#x4E2D;</symbol>
		</engine>'''

libbopomofo_engine = \
'''		<engine>
			<name>libbopomofo</name>
			<language>zh_TW</language>
			<license>GPL</license>
			<author>Peng Huang &lt;shawn.p.huang@gmail.com&gt;
                        BYVoid &lt;byvoid1@gmail.com&gt;
                        Peng Wu &lt;alexepico@gmail.com&gt;
                        </author>
			<icon>/usr/share/ibus-pinyin/icons/ibus-pinyin.svg</icon>
			<layout>us</layout>
			<longname>Intelligent Bopomofo</longname>
			<description>Intelligent Bopomofo input method</description>
			<rank>99</rank>
                        <!-- <hotkeys>Control+space,Alt+grave,Alt+Release+Alt_R</hotkeys> -->
                        <symbol>&#x4E2D;</symbol>
		</engine>'''

sqlite_path = "/usr/share/ibus-pinyin/db/"
sqlite_files = ["android.db", "open-phrase.db"]

libpinyin_path = "/usr/share/libpinyin/data/"
libpinyin_files = ["bigram.db", "gb_char.bin", "gbk_char.bin", "phrase_index.bin", "pinyin_index.bin"]


def check_sqlite():
    try:
        os.chdir(sqlite_path)
    except OSError:
        return False
    for onefile in sqlite_files:
        if os.access(onefile, os.R_OK):
            return True
    return False


def check_libpinyin():
    try:
        os.chdir(libpinyin_path)
    except OSError:
        return False
    for onefile in libpinyin_files:
        if not os.access(onefile, os.R_OK):
            return False
    return True


### main function ###
if __name__ == "__main__":
    print ("\t<engines>")
    if check_sqlite():
        print (pinyin_engine + os.linesep + bopomofo_engine)
    if check_libpinyin():
        print (libpinyin_engine + os.linesep + libbopomofo_engine)
    print ("\t</engines>")

